<?php
	#Herència. Treballant amb modificadors d'accés protected
	class cilindre {
		
		# Els atributs $radi i $longitud són protegits
		# Només és pot accedir al seu contingut des dins
		# de l'objecte però no des de fora.
		# Els atributs protegits SÍ es poden transmetre per herència.	
		protected $radi;
		protected $long;
		#Aquest atribut no està disponible per herència
		private $enable = 'y';
		
		public function __construct($r,$l){
			$this->radi = $r;
			$this->long = $l;
		}
		
		public function volum(){
			if ($this->enable == 'y') return M_PI * $this->radi**2 * $this->long;		
 		}	
	}
	
	# -----------------------Herència---------------------------------
	# La classe cost és una classe derivada de la classe base cilindre
	# La classe cilindre és la classe Pare o ascendent
	# La classe cost és una classe filla o descendent.
	# La classe filla cost hereta de la classe pare cilindre:
	#	a) Els atributs public i protected de la classe pare
	#   b) Els mètodes públics i protected de la clase pare
	# Les classes filles poden sobreescriure mètodes heretats de la classe pare
	class cost extends cilindre {
		
		private $costperm3;
		
		# El mètode __construct de la classe cost sobreescriu
		# el mètode __construct heretat de la classe pare.		
		public function __construct($cperm3,$r,$l){
			$this->radi = $r; # Podem accedir a radi per herència
			$this->long = $l; # Podem accedir a long per herència
			$this->costperm3 = $cperm3;
		}
				
		public function costfinal(){
			return $this->costperm3 * $this->volum();			
 		}	
	}
	
	$cost_cil = new cost(3,5,4);
	echo "El volum del cilindre és ".number_format($cost_cil->volum(),2)." centimetres cúbics<br>";
	echo "El cost de fabricació és ".number_format($cost_cil->costfinal(),2)." euros<br>";
	#Proves que donen errors perquè són atributs protegits o privats:
	#echo $cost_cil->radi."<br>";
	#echo $cost_cil->costperm3."<br>";
	#echo $cost_cil->enable."<br>";
?>
	
	
